#pragma once

#include "ACEXML/common/DefaultHandler.h"
#include <string>
#include <iostream>
#include <vector>
#include <fstream>
using namespace std;

//Ӧxmlļĸڵ
typedef struct _ROOT
{
	//汾
	int version;
	//
	int count;
} ROOT;

//Ӧxmlļ
typedef struct _FILE
{
	int id;
	//ļ·
	string path;
} ROOT_FILE;

#define XML_ROOT	"root"
#define XML_FILE	"file"
#define XML_ID		"id"
#define XML_VER		"version"
#define XML_COUNT	"count"

//ĳxmlļʽн
//ע⣺˶ṩ̻̰߳ʵĹ
class xml_handler : public ACEXML_DefaultHandler
{
public:
	//졣
	//@param name ַ룬xmlļ·
	xml_handler(char* path): filepath_(path), flag_(0) {}
	virtual ~xml_handler(){
		for(size_t i=0; i<files_.size(); ++i)
		{
			if(files_[i])
			{
				delete files_[i];
				files_[i] = 0;
			}
		}
		files_.clear();
	}
	//ȡxmlļ·
	const string& path() const
	{
		return filepath_;
	}
	//ȡӦroot.count
	const size_t count() const
	{
		return files_.size();
	}
	//ȡindexROOT_FILE
	//indexǰĸ򷵻0
	const ROOT_FILE* operator[](size_t index) const
	{
		if(index >= files_.size())
		{
			return 0;
		}
		return files_[index];
	}
	//ȡrootϢ
	const ROOT& root() const
	{
		return root_;
	}
	//һ
	//@param path ַ룬ļ·
	//@param id Σ룬ļid
	bool increase(const char* path, size_t id)
	{
		if(!path || *path == 0 || id == 0)
		{
			return false;
		}
		ROOT_FILE* file = new(std::nothrow)ROOT_FILE();
		//ڴʧ
		if(!file)
		{
			return false;
		}
		file->path = path;
		file->id = id;
		files_.push_back(file);
		return true;
	}
	//ǰrootfileϢд뵽xmlļ
	bool flush() const
	{
		ofstream ofs(filepath_.c_str(), ios_base::trunc);
		if(!ofs)
		{
			return false;
		}
		ofs << "<?xml version=\"1.0\"?>" << endl;
		ofs << "<" << XML_ROOT << " " << XML_VER << "=\"" << root_.version << "\" " << XML_COUNT << "=\"" << root_.count << "\" >" << endl;
		for(size_t i=0; i<files_.size(); ++i)
		{
			ofs << "\t<" << XML_FILE << " " << XML_ID << "=\"" << files_[i]->id << "\" >" << files_[i]->path << "</" << XML_FILE << ">" << endl;
		}
		ofs << "</" << XML_ROOT << ">" << endl;
		ofs.close();
		return true;
	}
	//ǰrootfileϢ̨
	void dump() const
	{
		cout << "<?xml version=\"1.0\"?>" << endl;
		cout << "<" << XML_ROOT << " " << XML_VER << "=\"" << root_.version << "\" " << XML_COUNT << "=\"" << root_.count << "\" >" << endl;
		for(size_t i=0; i<files_.size(); ++i)
		{
			cout << "\t<" << XML_FILE << " " << XML_ID << "=\"" << files_[i]->id << "\" >" << files_[i]->path << "</" << XML_FILE << ">" << endl;
		}
		cout << "</" << XML_ROOT << ">" << endl;
	}

public:

	virtual void characters( const ACEXML_Char *ch, size_t start, size_t length )
	{
		if(flag_ == FLAG_FILE)
		{
			files_[files_.size() - 1]->path = ch;
		}
		flag_ = FLAG_NULL;
	}

	virtual void endDocument( void )
	{
	}

	virtual void endElement( const ACEXML_Char *namespaceURI, const ACEXML_Char *localName, const ACEXML_Char *qName )
	{
		
	}

	virtual void endPrefixMapping( const ACEXML_Char *prefix )
	{
	}

	virtual void ignorableWhitespace( const ACEXML_Char *ch, int start, int length )
	{
	}

	virtual void processingInstruction( const ACEXML_Char *target, const ACEXML_Char *data )
	{
	}

	virtual void setDocumentLocator( ACEXML_Locator *locator )
	{
		locator_ = locator;
	}

	virtual void skippedEntity( const ACEXML_Char *name )
	{
	}

	virtual void startDocument( void )
	{
	}

	virtual void startElement( const ACEXML_Char *namespaceURI, const ACEXML_Char *localName, const ACEXML_Char *qName, ACEXML_Attributes *atts )
	{
		//fileڵ
		if(stricmp(localName, XML_FILE) == 0)
		{
			if(root_.count == files_.size())
			{
				return;
			}
			flag_ = FLAG_FILE;
			ROOT_FILE* file = new ROOT_FILE();
			files_.push_back(file);
			for(int i=0; i<atts->getLength(); ++i)
			{
				const char* qname = atts->getQName(i);
				if(stricmp(qname, XML_ID) == 0)
				{
					file->id = atoi(atts->getValue(i));
				}
			}
		}
		//rootڵ
		else if(stricmp(localName, XML_ROOT) == 0)
		{
			flag_ = FLAG_ROOT;
			for(int i=0; i<atts->getLength(); ++i)
			{
				const char* qname = atts->getQName(i);
				if(stricmp(qname, XML_VER) == 0)
				{
					root_.version= atoi(atts->getValue(i));
				}
				else if(stricmp(qname, XML_COUNT) == 0)
				{
					root_.count = atoi(atts->getValue(i));
				}
			}
		}
		
	}

	virtual void startPrefixMapping( const ACEXML_Char *prefix, const ACEXML_Char *uri )
	{
	}

	virtual void notationDecl( const ACEXML_Char *name, const ACEXML_Char *publicId, const ACEXML_Char *systemId )
	{
	}

	virtual void unparsedEntityDecl( const ACEXML_Char *name, const ACEXML_Char *publicId, const ACEXML_Char *systemId, const ACEXML_Char *notationName )
	{
		
	}

	virtual ACEXML_InputSource * resolveEntity( const ACEXML_Char *publicId, const ACEXML_Char *systemId )
	{
		return 0;
	}

	virtual void error( ACEXML_SAXParseException &exception )
	{
	}

	virtual void fatalError( ACEXML_SAXParseException &exception )
	{
	}

	virtual void warning( ACEXML_SAXParseException &exception )
	{
	}

private:
	//xmlļ·
	string filepath_;
	ACEXML_Locator* locator_;
	ROOT root_;
	vector<ROOT_FILE*> files_;
	enum FLAG
	{
		FLAG_NULL,
		FLAG_ROOT,
		FLAG_FILE,
	};
	int flag_;
};